#!/usr/bin/perl
# Author: Domen Puncer <domen@coderock.org>
# License: BSD, Beer Ware, whatever suits you.

# If you make improvements, please send them to me. TIA.

# order matters! ie. fs/cifs/ must be before fs/
my @mails = (
'jgarzik',	'sound_oss_via82cxxx_audio|drivers_block_sx8|drivers_char_hw_random',
	'jgarzik@pobox.com linux-kernel@vger.kernel.org',
'alpha',	'arch_alpha',
	'rth@twiddle.net linux-kernel@vger.kernel.org',
'arm26',	'arch_arm26|drivers_acorn_block',
	'spyro@f2s.com linux-kernel@vger.kernel.org',
'arm',		'arch_arm|include_asm_arm',
	'rmk@arm.linux.org.uk linux-kernel@vger.kernel.org',
'cris',		'arch_cris_',
	'starvik@axis.com dev-etrax@axis.com',
'h8300',	'arch_h8300_',
 	'ysato@users.sourceforge.jp linux-kernel@vger.kernel.org',
'ia64',		'arch_ia64_',
	'tony.luck@intel.com linux-ia64@vger.kernel.org',
'mips',		'arch_mips|include_asm_mips',
	'ralf@linux-mips.org linux-mips@linux-mips.org',
'm68k',		'arch_m68k_',
	'geert@linux-m68k.org zippel@linux-m68k.org linux-m68k@lists.linux-m68k.org',
'm68knommu',	'arch_m68knommu|include_asm_m68knommu',
	'gerg@snapgear.com linux-kernel@vger.kernel.org', # uclinux-dev sub only
'parisc',	'arch_parisc_|drivers_parisc',
	'matthew@wil.cx grundler@parisc-linux.org parisc-linux@parisc-linux.org',
'ppc64',	'arch_ppc64|include_asm_ppc64',
	'paulus@samba.org anton@samba.org linuxppc64-dev@ozlabs.org',
'ppc',		'arch_ppc_',
	'paulus@samba.org linuxppc-dev@ozlabs.org',
's390',		'drivers_s390',
	'schwidefsky@de.ibm.com linux390@de.ibm.com',
'sh64',		'arch_sh64_',
	'lethal@linux-sh.org rc@rc0.org.uk',
'sh',		'arch_sh',
	'lethal@linux-sh.org kkojima@rr.iij4u.or.jp', # linux-sh@m17n.org is sub only; add lkml?
'sparc64',	'arch_sparc|drivers_sbus',
	'davem@davemloft.net sparclinux@vger.kernel.org',
'sparc',	'arch_sparc',
	'wli@holomorphy.com sparclinux@vger.kernel.org',
'um',		'arch_um_',
	'jdike@karaya.com user-mode-linux-devel@lists.sourceforge.net',
'x86_64',	'arch_x86_64_|include_asm-x86_64_',
	'ak@suse.de discuss@x86-64.org',

'acpi',		'drivers_acpi|arch_i386_pci_acpi',
	'len.brown@intel.com acpi-devel@lists.sourceforge.net',
'atm',		'drivers_atm',
	'chas@cmf.nrl.navy.mil linux-atm-general@lists.sourceforge.net',
'block-paride',	'drivers_block_paride',
	'tim@cyberelk.net linux-parport@lists.infradead.org',
'block-ataflop','drivers_block_ataflop',
	'paul@paulbristow.net linux-kernel@vger.kernel.org',
'block-cciss',	'drivers_block_cciss',
	'mike.miller@hp.com iss_storagedev@hp.com',
'block',	'drivers_block|drivers_acorn_block',
	'axboe@suse.de linux-kernel@vger.kernel.org',
'cdrom',	'drivers_cdrom_',
	'emoenke@gwdg.de linux-kernel@vger.kernel.org',
'agp',		'drivers_char_agp',
	'davej@codemonkey.org.uk linux-kernel@vger.kernel.org',
'char-snsc',	'drivers_char_snsc',
	'ghoward@sgi.com linux-kernel@vger.kernel.org',
'drm',		'drivers_char_drm',
	'airlied@linux.ie dri-devel@lists.sourceforge.net',
'i2c',		'drivers_i2c',
	'khali@linux-fr.org greg@kroah.com sensors@stimpy.netroedge.com',
'ide-tape',	'drivers_ide_ide-tape',
	'gadio@netvision.net.il B.Zolnierkiewicz@elka.pw.edu.pl linux-ide@vger.kernel.org',
'ide',		'drivers_ide',
	'B.Zolnierkiewicz@elka.pw.edu.pl linux-ide@vger.kernel.org',
'ieee1394',	'drivers_ieee1394',
	'bcollins@debian.org linux1394-devel@lists.sourceforge.net',
'input',	'drivers_input',
	'vojtech@suse.cz linux-input@atrey.karlin.mff.cuni.cz',
'isdn',		'drivers_isdn',
	'kkeil@suse.de isdn4linux@listserv.isdn4linux.de',
'macintosh',	'drivers_macintosh',
	'benh@kernel.crashing.org linuxppc-dev@ozlabs.org',
'dvb',		'drivers_media_dvb',
	'linux-dvb-maintainer@linuxtv.org',
#	'linux-dvb@linuxtv.org',
'saa7146',	'drivers_media_common_saa7146',
	'michael@mihu.de video4linux-list@redhat.com',
'media-video-meye', 'drivers_media_video_meye',
	'stelian@popies.net video4linux-list@redhat.com',
'media-video',	'drivers_media_video|drivers_media_radio', # hmm?
	'linux-dvb-maintainer@linuxtv.org mchehab@brturbo.com.br video4linux-list@redhat.com',
'framebuffer',	'drivers_video',
	'adaplas@pol.net linux-fbdev-devel@lists.sourceforge.net',
'mtd',		'drivers_mtd',
	'dwmw2@infradead.org linux-mtd@lists.infradead.org',
'irda',		'drivers_net_irda',
	'jt@hpl.hp.com irda-users@lists.sourceforge.net',
'appletalk',	'drivers_net_appletalk',
	'acme@conectiva.com.br netdev@vger.kernel.org',
'tokenring',	'drivers_net_tokenring',
	'mikep@linuxtr.net netdev@vger.kernel.org',
'prism',	'drivers_net_wireless_prism54',
	'prism54-private@prism54.org netdev@vger.kernel.org',
'orinoco',	'drivers_net_wireless_orinoco',
	'proski@gnu.org hermes@gibson.dropbear.id.au netdev@vger.kernel.org',
'ppp',		'drivers_net_ppp',
	'paulus@samba.org linux-ppp@vger.kernel.org',
'wan-sangoma',	'drivers_net_wan_(sdla|wanpipe)',
	'ncorbic@sangoma.com dm@sangoma.com netdev@vger.kernel.org',
#'hamradio-baycom', 'drivers_net_hamradio_baycom',
#	't.sailer@alumni.ethz.ch linux-hams@vger.kernel.org',
'hamradio',	'drivers_net_hamradio',
	'ralf@linux-mips.org linux-hams@vger.kernel.org',
'net-wan',	'drivers_net_wan_',
	'ncorbic@sangoma.com netdev@vger.kernel.org',
'smc91x',	'drivers_net_pcmcia_smc91',
	'nico@cam.org netdev@vger.kernel.org',
'net',		'net|include_linux_skbuff|drivers_net_tg3.c',
	'davem@redhat.com netdev@vger.kernel.org',
'drivers-net-hp100',	'drivers_net_hp100',
	'perex@suse.cz jgarzik@pobox.com netdev@vger.kernel.org',
'drivers-net-pcnet32',	'drivers_net_pcnet32',
	'tsbogend@alpha.franken.de netdev@vger.kernel.org',
'bluetooth',	'drivers_bluetooth|include_net_bluetooth',
	'marcel@holtmann.org bluez-devel@lists.sf.net',
'bonding',	'drivers_net_bonding_',
	'ctindel@users.sourceforge.net bonding-devel@lists.sourceforge.net',
'wireless-wavelan','drivers_net_wireless_wavelan',
	'jt@hpl.hp.com netdev@vger.kernel.org',
'wireless-atmel','drivers_net_wireless_atmel',
	'simon@thekelleys.org.uk netdev@vger.kernel.org',
'drivers-net',	'drivers_net',
	'jgarzik@pobox.com netdev@vger.kernel.org',
'netfilter',	'net_bridge_netfilter|include_linux_netfilter',
	'coreteam@netfilter.org netfilter-devel@lists.netfilter.org',
'dm-crypt',	'drivers_md_dm-crypt',
	'clemens@endorphin.org linux-kernel@vger.kernel.org',
'mca',		'drivers_mca_',
	'jejb@steeleye.com linux-kernel@vger.kernel.org',
'parport',	'drivers_parport',
	'philb@gnu.org linux-parport@lists.infradead.org',
'pci',		'drivers_pci|arch_i386_pci',
	'gregkh@suse.de linux-kernel@vger.kernel.org',
'sata',		'drivers_scsi_(sata|ahci|pata|libata|ata_)|include_linux_(ata|libata|sata)',
	'jgarzik@pobox.com linux-ide@vger.kernel.org',
'scsi-osst',	'drivers_scsi_osst',
	'osst@riede.org linux-scsi@vger.kernel.org',
'scsi-qla2xxx',	'drivers_scsi_qla2xxx',
	'andrew.vasquez@qlogic.com linux-scsi@vger.kernel.org',
'scsi-aacraid',	'drivers_scsi_aacraid',
	'mark_salyzyn@adaptec.com linux-scsi@vger.kernel.org',
'scsi',		'drivers_scsi',
	'James.Bottomley@SteelEye.com linux-scsi@vger.kernel.org',
'alsa',		'sound_isa|sound_pci|sound_core',
	'perex@suse.cz alsa-devel@alsa-project.org',
'usblp',	'drivers_usb_class_usblp',
	'vojtech@suse.cz linux-usb-devel@lists.sourceforge.net',
'usb-digi',	'drivers_usb_serial_digi_acceleport',
	'pberger@brimson.com gregkh@suse.de linux-usb-devel@lists.sourceforge.net',
'usb',		'drivers_usb',
	'gregkh@suse.de linux-usb-devel@lists.sourceforge.net',
'w1',		'drivers_w1',
	'johnpol@2ka.mipt.ru sensors@stimpy.netroedge.com',
'fs-affs',	'fs_affs',
	'zippel@linux-m68k.org linux-fsdevel@vger.kernel.org',
'fs-befs',	'fs_befs',
	'rathamahata@php4.ru linux-kernel@vger.kernel.org',
'fs-cifs',	'fs_cifs',
	'sfrench@samba.org samba-technical@lists.samba.org',
'fs-ext2',	'fs_ext2',
	'ext2-devel@lists.sourceforge.net',
'fs-ext3',	'fs_ext3',
	'sct@redhat.com ext3-users@redhat.com',
'fs-hpfs',	'fs_hpfs',
	'mikulas@artax.karlin.mff.cuni.cz linux-fsdevel@vger.kernel.org',,
'fs-jffs2',	'fs_jffs2',
	'dwmw2@infradead.org jffs-dev@axis.com',
'fs-jffs',	'fs_jffs',
	'jffs-dev@axis.com',
'fs-jfs',	'fs_jfs',
	'shaggy@austin.ibm.com jfs-discussion@oss.software.ibm.com',
'fs-nfsd',	'fs_nfsd',
	'neilb@cse.unsw.edu.au nfs@lists.sourceforge.net',
'fs-qnx4',	'fs_qnx4',
	'al@alarsen.net linux-kernel@vger.kernel.org',
'fs-reiser',	'fs_reiserfs',
	'reiserfs-dev@namesys.com',
'fs-smbfs',	'fs_smbfs|include_linux_smb',
	'urban@teststation.com samba@samba.org',
'fs-xfs',	'fs_xfs',
	'xfs-masters@oss.sgi.com nathans@sgi.com linux-xfs@oss.sgi.com',
'fs-bio',	'fs_bio',
	'axboe@suse.de linux-fsdevel@vger.kernel.org',
'fs-dquot',	'fs_dquot',
	'jack@suse.cz linux-kernel@vger.kernel.org',
'fs',		'fs_',
	'viro@parcelfarce.linux.theplanet.co.uk linux-fsdevel@vger.kernel.org',
'power',	'kernel_power',
	'pavel@suse.cz linux-kernel@vger.kernel.org',
'watchdog',	'drivers_char_watchdog|include_asm-ppc_mv64x60.h',
	'wim@iguana.be linux-kernel@vger.kernel.org',
'message_fusion','drivers_message_fusion',
	'sjralston1@netscape.net mpt_linux_developer@lsil.com',
'selinux',	'security_selinux',
	'sds@epoch.ncsc.mil jmorris@redhat.com linux-kernel@vger.kernel.org',
'crypto',	'crypto_',
	'herbert@gondor.apana.org.au davem@davemloft.net linux-kernel@vger.kernel.org',
'kernel-module','kernel_module|include_linux_module',
	'rusty@rustcorp.com.au linux-kernel@vger.kernel.org',
'mm',		'mm_|arch_i386_mm',
	'akpm@osdl.org linux-mm@kvack.org',
'akpm',		'.',
	'akpm@osdl.org linux-kernel@vger.kernel.org'
);


#aoeu - /marker :-)
#goto next_stage;
# cleanup old files
unlink <pbomb.*>;

open(series, 'pbomb');
@series = <series>;
close(series);
#chomp(@series);
open(dontsend, 'patches.dontsend');
@dontsend = <dontsend>;
chomp(@dontsend);
close(dontsend);

foreach $patch (@series) {
	my $i;
	my $skip = 0;

	# skip these
	for ($i=0; $i<=$#dontsend; $i++) {
		if ($patch eq "@dontsend[$i]\n" or $patch eq "@dontsend[$i].patch\n") {
			$skip = 1;
		}
	}
	if ($skip == 1) {
		next;
	}

	for ($i=0; $i<=$#mails; $i+=3) {
		if ($patch =~ /-@mails[$i+1]/ or @mails[$i] eq "akpm") {
			open(pbomb, '>>pbomb.'.@mails[$i]);

			print(pbomb $patch);
			close(pbomb);

			last;
		}
	}
}

next_stage:
	for ($i=0; $i<=$#mails; $i+=3) {
		# add mails
		my $fname = 'pbomb.'.@mails[$i];
		if (-s $fname) {
			my ($mail, $to);
			@to_mails = split / /, @mails[$i+2];
			foreach $mail (@to_mails) {
				if (!$to) {
					$to = $to . "--to $mail";
				} else {
					$to = $to . " --cc $mail";
				}
			}
			system("quilt mail --mbox mbox." . @mails[$i] .
					" --series $fname" .
					" --from domen\@coderock.org" .
					" $to --nofile --nointr");
			print("quilt mail --send" .
					" --series $fname" .
					" --from domen\@coderock.org" .
					" $to --nofile --nointr\n");
			print("sleep 5\n\n");
		}
	}
system('cat mbox.* > mbox');
